'===============================================================================
' String.bas
' Stringverarbeitungsfunktionen
' Erstellt am 07.12.2013
' Letzte Bearbeitung am 04.10.14
'===============================================================================


Function CountString(s1 As String, s2 As String) As Integer
	'Gibt zurueck, wie oft der String s2 im String s1 vorkommt
	
	Dim As Integer i, count
	
	count = 0
	i = 0
	Do
		i = i + 1
		If Mid(s1, i, Len(s2)) = s2 Then count = count + 1
	Loop Until i = Len(s1)
	
	Return count  
	
End Function


Function SubString(s1 As String, s2 As String, k As Integer) As String
	'Liefert den k-ten Substring in einem String s1 mit der Trennzeichenfolge s2.
	'k beginnt ab 1

	Dim As Integer i, count
	Dim As String s
	
	If k = 0 Or s2 = "" Or Instr(s1, s2) = 0 Then
		Return s1
	ElseIf k = 1 Then
		Return Left(s1, Instr(s1, s2) - 1)
	Else
		'Startwert suchen:
		count = 0
		i = 0
		Do
			i = Instr(i + 1, s1, s2)
			count = count + 1
		Loop Until count = k - 1
		'Substring zusammenpuzzeln:
		s = ""
		i = i + Len(s2) - 1
		Do
			i = i + 1
			If Mid(s1, i, Len(s2)) = s2 Or i > Len(s1) Then Exit Do
			s = s + Mid(s1, i, 1)
		Loop
		Return s
	End If

End Function
		
		 
Function ReplaceString(s1 As String, s2 As String, s3 As String) As String
	'Ersetzt alle Teilstrings s2 in s1 durch den String s3 und gibt den
	'geänderten String zurueck
	
	Dim As Integer i
	Dim As String s
	
	s = s1
	i = 0
	Do
		i = i + 1
		If Mid(s, i, Len(s2)) = s2 Then
			s = Left(s, i - 1) + s3 + Right(s, Len(s) - i - Len(s2) + 1)
			i = i + Len(s3) - 1
		End If
	Loop Until i >= Len(s)
	
	Return s
	
	
End Function


Function InsertString(s1 As String, s2 As String, k As Integer) As String
	'Fuegt im String s1 an der Stelle k den String s2 ein
	
	Return Left(s1, k - 1) + s2 + Right(s1, Len(s1) - k + 1)
	
End Function


Function LeftSet(s As String, Laenge As Integer) As String
  'Gibt den String s linksbündig mit der angegebenen Laenge aus
  
	Return s + Space(Laenge - Len(s))
  
End Function


Function RightSet(s As String, Laenge As Integer) As String
  'Gibt den String s rechtsbuendig mit der angegebenen Laenge aus
  
  Return Space(Laenge - Len(s)) + s
  
End Function
  
